#include <string.h>
#include <stdlib.h>

#define sortFloats(d,x)  qsort(d,x,sizeof(float),compareFloats)

#define showVector(data, n) do {int _i; for(_i = 0;_i<n;++_i)\
				    printf("%g,",(double)data[_i]);printf("\n");} while(0)

#define showArray(data,nx,ny) do {int _i,_j,_c;\
				      for(_c=_i = 0;_i<ny;++_i) {\
					 printf("%3d: ",_i);\
					 for(_j =0;_j<nx;++_j,++_c)\
					  printf("%8.4g,",(double)data[_c]);\
				      printf("\n");}} while(0)


int compareInts(const void *i1, const void *i2)
{
    if(*(int*)i1 > *(int*)i2)
	return 1;
    else if(*(int*)i1 <  *(int*)i2)
	return -1;
    else
	return 0;
}
int compareFloats(const void *i1, const void *i2)
{
    if(*(float*)i1 > *(float*)i2)
	return 1;
    else if(*(float*)i1 <  *(float*)i2)
	return -1;
    else
	return 0;
}



void subarray(void *IN, void *OUT, int n, int sizein, int sizeout)
{
    /* Subset `n' elements form the array in `in' and
     * place them in `out'
     * usage:
     *		subarray(data,sub,28,sizeof(*data),sizeof(*sub));
     */

    char *in = IN;
    char *out = OUT;
    int i;
    for(i=0;i<n;i++,in+=sizein,out+=sizeout)
	memcpy(out,in,sizeout);
}


int * float2int(float *f, int n)
{
    /* convert a float  array to an int array
     *
     * The returned array is static.
     */
    static int *d=NULL;
    int i;

    d = realloc(d,sizeof(int)*n);
    for(i=0;i<n;++i,++f,++d)
	*d = *f;
    d -= n;
    return d;
}

float * int2float(int *f, int n)
{
    /* convert an int array to a float array
     *
     * The returned array is static.
     */
    static float *d=NULL;
    int i;

    d = realloc(d,sizeof(float)*n);
    for(i=0;i<n;++i,++f,++d)
	*d = *f;
    d -= n;
    return d;
}


float * readarray(char *fname, int ncols)
{
    /* Read a 2D array of ascii numerical values
     * from file `fname'. It will assume that the file
     * format consists of nrows by ncols.
     * It returns a pointer to the data read,
     * plus it will print out the number of rows read.
     *
     * The returned array is dynamic. That is, it is
     * your responsibility to free it.
     * p.s this code should be made safe for the weak
     * at heart.
     */
    
    float *data=NULL;
    FILE *fp;
    int i = 0;
    fp = fopen(fname,"r");
    if(!fp)
	return 0;
    do 
	data = realloc(data,++i * sizeof(float));
    while(fscanf(fp,"%g",&data[i-1]) == 1);
    printf("nrows = %d\n",i/ncols);
    fclose(fp);
    return data;
}    
    

float getRange(float * data, int n)
{
    int i;
    float mx, mn;
    mx = mn = *data++;
    for(i=1;i<n;++i,++data) {
	if(mx < *data)
	    mx = *data;
	if(mn > *data)
	    mn = *data;
    }

    return mx - mn;

}
    
    
